/*********************************************************************
*                      SEGGER Microcontroller GmbH                   *
*                        The Embedded Experts                        *
**********************************************************************
*                                                                    *
*      (c) 2018  SEGGER Microcontroller GmbH                         *
*                                                                    *
*       www.segger.com     Support: support@segger.com               *
*                                                                    *
**********************************************************************
----------------------------------------------------------------------
File    : STM32F7xx_HAL_Overwrite.c
Purpose : Function overwrites.
--------  END-OF-HEADER  ---------------------------------------------
*/

#include "stm32f7xx_hal.h"
#include "RTOS.h"

/*********************************************************************
*
*       HAL_GetTick()
*
*  Function description
*    Overwrite of HAL_GetTick.
*
* Additional information
*   HAL_GetTick of STM32 HAL is declared as __weak to be overwritten
*   in case of other implementations in user file.
*   In this project, we use OS_GetTime().
*/
/**
  * @brief Provides a tick value in millisecond.
  * @note This function is declared as __weak to be overwritten in case of other 
  *       implementations in user file.
  * @retval tick value
  */
uint32_t HAL_GetTick(void) {
  return OS_GetTime();
}

/****** End Of File *************************************************/