/*********************************************************************
*                                                                    *
*                SEGGER Microcontroller GmbH                         *
*        Solutions for real time microcontroller applications        *
*                                                                    *
**********************************************************************
*                                                                    *
* C-file generated by:                                               *
*                                                                    *
*        GUI_Builder for emWin version 5.48                          *
*        Compiled Jun 13 2018, 10:51:02                              *
*        (c) 2018 Segger Microcontroller GmbH                        *
*                                                                    *
**********************************************************************
*                                                                    *
*        Internet: www.segger.com  Support: support@segger.com       *
*                                                                    *
**********************************************************************
*/

#include "DIALOG.h"
#include "WeatherStation.h"
#include "Resource.h"

#include <stdio.h>

/*********************************************************************
*
*       Defines
*
**********************************************************************
*/
#define ID_WINDOW_0           (GUI_ID_USER + 0x00)
#define ID_TEXT_0             (GUI_ID_USER + 0x01)
#define ID_TEXT_1             (GUI_ID_USER + 0x02)

#define MESSAGE_SET_TIME      (WM_USER + 0x00)

/*********************************************************************
*
*       Static data
*
**********************************************************************
*/
static const char* const _acMonth[] = {
  "January",
  "February",
  "March",
  "April",
  "May",
  "June",
  "July",
  "August",
  "September",
  "October",
  "November",
  "December"
};

/*********************************************************************
*
*       _aDialogCreate
*/
static const GUI_WIDGET_CREATE_INFO _aDialogCreate[] = {
  { WINDOW_CreateIndirect, "Window1", ID_WINDOW_0, 0, 0, 272, 100, 0, 0x0, 0 },
  { TEXT_CreateIndirect, "Text", ID_TEXT_0, 15, 45, 242, 40, 0, 0x64, 0 },
  { TEXT_CreateIndirect, "Text", ID_TEXT_1, 15, 15, 242, 30, 0, 0x64, 0 },
};

static WM_HWIN _hWinTime;

/*********************************************************************
*
*       Static code
*
**********************************************************************
*/

/*********************************************************************
*
*       _cbDialog
*/
static void _cbDialog(WM_MESSAGE* pMsg) {
  WM_HWIN         hItem;
  UTIL_DATE_TIME* pTimeInfo;
  char            acBuffer[32];

  switch (pMsg->MsgId) {
  case WM_INIT_DIALOG:
    WINDOW_SetBkColor(pMsg->hWin, COLOR_BK);
    //
    hItem = WM_GetDialogItem(pMsg->hWin, ID_TEXT_0);
    TEXT_SetTextAlign(hItem, GUI_TA_HCENTER | GUI_TA_VCENTER);
    TEXT_SetTextColor(hItem, COLOR_LIGHT);
    TEXT_SetFont(hItem, &GUI_Font_36_AA4);
    TEXT_SetText(hItem, "00:00:00");
    //
    hItem = WM_GetDialogItem(pMsg->hWin, ID_TEXT_1);
    TEXT_SetTextAlign(hItem, GUI_TA_HCENTER | GUI_TA_VCENTER);
    TEXT_SetTextColor(hItem, COLOR_LIGHT);
    TEXT_SetFont(hItem, &GUI_Font_22_AA4);
    TEXT_SetText(hItem, "1 January 1900");
    break;
  case MESSAGE_SET_TIME:
    pTimeInfo = (UTIL_DATE_TIME*)pMsg->Data.p;

    hItem = WM_GetDialogItem(pMsg->hWin, ID_TEXT_1);
    sprintf(acBuffer, "%d %s %d", pTimeInfo->Day, _acMonth[pTimeInfo->Month - 1], pTimeInfo->Year);
    TEXT_SetText(hItem, acBuffer);
    
    hItem = WM_GetDialogItem(pMsg->hWin, ID_TEXT_0);
    sprintf(acBuffer, "%02d:%02d:%02d", pTimeInfo->Hour, pTimeInfo->Minute, pTimeInfo->Second);
    TEXT_SetText(hItem, acBuffer);

    break;
  default:
    WM_DefaultProc(pMsg);
    break;
  }
}

/*********************************************************************
*
*       Public code
*
**********************************************************************
*/

/*********************************************************************
*
*       GUI_UpdateTime()
*
* Function description
*   Updates the GUI to the correct time
*/
void GUI_UpdateTime(UTIL_DATE_TIME* ptime) {
  WM_MESSAGE Message;

  Message.Data.p  =  ptime;
  Message.MsgId   =  MESSAGE_SET_TIME;
  Message.hWin    = _hWinTime;
  WM_SendMessage(_hWinTime, &Message);
}

/*********************************************************************
*
*       CreateWindow1
*/
WM_HWIN CreateWindow1(void) {
  _hWinTime = GUI_CreateDialogBox(_aDialogCreate, GUI_COUNTOF(_aDialogCreate), _cbDialog, WM_HBKWIN, 0, 0);
  return _hWinTime;
}

/*************************** End of file ****************************/
