/*********************************************************************
*                                                                    *
*                SEGGER Microcontroller GmbH                         *
*        Solutions for real time microcontroller applications        *
*                                                                    *
**********************************************************************
*                                                                    *
* C-file generated by:                                               *
*                                                                    *
*        GUI_Builder for emWin version 5.48                          *
*        Compiled Jun 13 2018, 10:51:02                              *
*        (c) 2018 Segger Microcontroller GmbH                        *
*                                                                    *
**********************************************************************
*                                                                    *
*        Internet: www.segger.com  Support: support@segger.com       *
*                                                                    *
**********************************************************************
*/

#include "DIALOG.h"
#include "Resource.h"
#include "WeatherStation.h"

/*********************************************************************
*
*       Defines
*
**********************************************************************
*/
#define ID_WINDOW_0            (GUI_ID_USER + 0x01)
#define ID_IMAGE_0             (GUI_ID_USER + 0x02)
#define ID_TEXT_0              (GUI_ID_USER + 0x03)
#define ID_TEXT_1              (GUI_ID_USER + 0x04)
#define ID_TEXT_2              (GUI_ID_USER + 0x05)

#define MESSAGE_UPDATE_WEATHER (WM_USER + 0x10)

#define WEATHER_ICON_POS_X0    (40)
#define WEATHER_ICON_POS_Y0    (35)
#define WEATHER_ICON_SIZE_X    (50)
#define WEATHER_ICON_SIZE_Y    (50)
#define WEATHER_ICON_POS_X1    (WEATHER_ICON_POS_X0 + WEATHER_ICON_SIZE_X)
#define WEATHER_ICON_POS_Y1    (WEATHER_ICON_POS_Y0 + WEATHER_ICON_SIZE_Y)

/*********************************************************************
*
*       Static data
*
**********************************************************************
*/

static WM_HWIN _hWin;

/*********************************************************************
*
*       _aDialogCreate
*/
static const GUI_WIDGET_CREATE_INFO _aDialogCreate[] = {
  { WINDOW_CreateIndirect, "Window2", ID_WINDOW_0, 0, 100, 272, 120, 0, 0x0, 0 },
  { TEXT_CreateIndirect, "Text", ID_TEXT_0, 87, 10, 150, 25, 0, 0x64, 0 },
  { TEXT_CreateIndirect, "Text", ID_TEXT_1, 87, 85, 150, 25, 0, 0x64, 0 },
  { TEXT_CreateIndirect, "Text", ID_TEXT_2, 87, 35, 150, 50, 0, 0x64, 0 },
};

static const GUI_BITMAP * _apWeatherIcon[] = {
  &bmsun50,
  &bmchance_of_storm50,
  &bmcloud_lighting50,
  &bmclouds50,
  &bmfog_day50,
  &bmpartly_cloudy_day50,
  &bmrain50,
  &bmsnow50
};

/*********************************************************************
*
*       Static code
*
**********************************************************************
*/

/*********************************************************************
*
*       _cbDialog
*/
static void _cbDialog(WM_MESSAGE * pMsg) {
  WM_HWIN      hItem;
  U32          v;

  switch (pMsg->MsgId) {
  case WM_INIT_DIALOG:
    WINDOW_SetBkColor(pMsg->hWin, GUI_BLACK);
    //
    // Initialization of 'Text'
    //
    hItem = WM_GetDialogItem(pMsg->hWin, ID_TEXT_0);
    TEXT_SetTextAlign(hItem, GUI_TA_RIGHT | GUI_TA_VCENTER);
    TEXT_SetTextColor(hItem, COLOR_YELLOW);
    TEXT_SetFont(hItem, &GUI_Font_24_AA4);
    TEXT_SetText(hItem, WEATHER_APP_CITY_DISPLAY);
    //
    // Initialization of 'Text'
    //
    hItem = WM_GetDialogItem(pMsg->hWin, ID_TEXT_1);
    TEXT_SetTextAlign(hItem, GUI_TA_RIGHT | GUI_TA_VCENTER);
    TEXT_SetTextColor(hItem, COLOR_YELLOW);
    TEXT_SetFont(hItem, &GUI_Font_24_AA4);
    TEXT_SetText(hItem, "Sunny");
    //
    // Initialization of 'Text'
    //
    hItem = WM_GetDialogItem(pMsg->hWin, ID_TEXT_2);
    TEXT_SetTextAlign(hItem, GUI_TA_RIGHT | GUI_TA_VCENTER);
    TEXT_SetTextColor(hItem, COLOR_LIGHT);
    TEXT_SetFont(hItem, &GUI_Font_50_AA4);
    TEXT_SetText(hItem, "20C");

    break;
  case WM_PAINT:
    GUI_SetBkColor(COLOR_BK);
    GUI_Clear();
    GUI_SetColor(COLOR_LIGHT);
    GUI_ClearRect(WEATHER_ICON_POS_X0, WEATHER_ICON_POS_Y0, WEATHER_ICON_POS_X1, WEATHER_ICON_POS_Y1);
    v = GetWeatherIconId(MAIN_WeatherNow.acWeatherIcon);
    GUI_DrawBitmap(_apWeatherIcon[v], WEATHER_ICON_POS_X0, WEATHER_ICON_POS_Y0);
    break;
  case MESSAGE_UPDATE_WEATHER:
    hItem = WM_GetDialogItem(pMsg->hWin, ID_TEXT_2);
    TEXT_SetText(hItem, MAIN_WeatherNow.acTemp);
    hItem = WM_GetDialogItem(pMsg->hWin, ID_TEXT_1);
    TEXT_SetText(hItem, MAIN_WeatherNow.acWeather);
    break;
  default:
    WM_DefaultProc(pMsg);
    break;
  }
}

/*********************************************************************
*
*       Public code
*
**********************************************************************
*/

/*********************************************************************
*
*       GUI_UpdateWeatherNow()
*
* Function description
*   Updates the GUI to the correct weather
*/
void GUI_UpdateWeatherNow(void) {
  WM_MESSAGE Message;

  Message.MsgId   =  MESSAGE_UPDATE_WEATHER;
  Message.hWin    = _hWin;
  WM_SendMessage(_hWin, &Message);

  WM_InvalidateWindow(_hWin);
}

/*********************************************************************
*
*       CreateWindow2
*/
WM_HWIN CreateWindow2(void) {
  _hWin = GUI_CreateDialogBox(_aDialogCreate, GUI_COUNTOF(_aDialogCreate), _cbDialog, WM_HBKWIN, 0, 0);
  return _hWin;
}

/*************************** End of file ****************************/
