/*********************************************************************
*                                                                    *
*                SEGGER Microcontroller GmbH                         *
*        Solutions for real time microcontroller applications        *
*                                                                    *
**********************************************************************
*                                                                    *
* C-file generated by:                                               *
*                                                                    *
*        GUI_Builder for emWin version 5.48                          *
*        Compiled Jun 13 2018, 10:51:02                              *
*        (c) 2018 Segger Microcontroller GmbH                        *
*                                                                    *
**********************************************************************
*                                                                    *
*        Internet: www.segger.com  Support: support@segger.com       *
*                                                                    *
**********************************************************************
*/

#include "DIALOG.h"
#include "Resource.h"
#include "WeatherStation.h"

/*********************************************************************
*
*       Defines
*
**********************************************************************
*/
#define ID_WINDOW_0   (GUI_ID_USER + 0x02)
#define ID_IMAGE_0    (GUI_ID_USER + 0x03)
#define ID_IMAGE_1    (GUI_ID_USER + 0x04)
#define ID_IMAGE_2    (GUI_ID_USER + 0x05)
#define ID_IMAGE_3    (GUI_ID_USER + 0x06)
#define ID_IMAGE_4    (GUI_ID_USER + 0x07)
#define ID_IMAGE_5    (GUI_ID_USER + 0x08)

#define MESSAGE_UPDATE_WEATHER_FORECAST   (WM_USER + 0x11)

#define ID_TEXT_00    (GUI_ID_USER + 0x0B)
#define ID_TEXT_01    (GUI_ID_USER + 0x0C)
#define ID_TEXT_02    (GUI_ID_USER + 0x0D)
#define ID_TEXT_10    (GUI_ID_USER + 0x0E)
#define ID_TEXT_11    (GUI_ID_USER + 0x0F)
#define ID_TEXT_12    (GUI_ID_USER + 0x10)
#define ID_TEXT_20    (GUI_ID_USER + 0x11)
#define ID_TEXT_21    (GUI_ID_USER + 0x12)
#define ID_TEXT_22    (GUI_ID_USER + 0x13)
#define ID_TEXT_30    (GUI_ID_USER + 0x14)
#define ID_TEXT_31    (GUI_ID_USER + 0x15)
#define ID_TEXT_32    (GUI_ID_USER + 0x16)
#define ID_TEXT_40    (GUI_ID_USER + 0x17)
#define ID_TEXT_41    (GUI_ID_USER + 0x18)
#define ID_TEXT_42    (GUI_ID_USER + 0x19)



/*********************************************************************
*
*       Static data
*
**********************************************************************
*/

static const GUI_BITMAP * _apWeatherIcon[] = {
  &bmsun50,
  &bmchance_of_storm50,
  &bmcloud_lighting50,
  &bmclouds50,
  &bmfog_day50,
  &bmpartly_cloudy_day50,
  &bmrain50,
  &bmsnow50
};

static WM_HWIN _hWin;

/*********************************************************************
*
*       _aDialogCreate
*/
static const GUI_WIDGET_CREATE_INFO _aDialogCreate[] = {
  { WINDOW_CreateIndirect, "Window3", ID_WINDOW_0, 0, 220, 400, 140, 0, 0x0, 0 },
  { TEXT_CreateIndirect, "Text", ID_TEXT_00, 15, 10, 50, 20, 0, 0x64, 0 },
  { TEXT_CreateIndirect, "Text", ID_TEXT_01, 15, 30, 50, 20, 0, 0x64, 0 },
  { TEXT_CreateIndirect, "Text", ID_TEXT_02, 15, 110, 50, 20, 0, 0x64, 0 },

  { TEXT_CreateIndirect, "Text", ID_TEXT_10, 95, 10, 50, 20, 0, 0x64, 0 },
  { TEXT_CreateIndirect, "Text", ID_TEXT_11, 95, 30, 50, 20, 0, 0x64, 0 },
  { TEXT_CreateIndirect, "Text", ID_TEXT_12, 95, 110, 50, 20, 0, 0x64, 0 },

  { TEXT_CreateIndirect, "Text", ID_TEXT_20, 175, 10, 50, 20, 0, 0x64, 0 },
  { TEXT_CreateIndirect, "Text", ID_TEXT_21, 175, 30, 50, 20, 0, 0x64, 0 },
  { TEXT_CreateIndirect, "Text", ID_TEXT_22, 175, 110, 50, 20, 0, 0x64, 0 },

  { TEXT_CreateIndirect, "Text", ID_TEXT_30, 255, 10, 50, 20, 0, 0x64, 0 },
  { TEXT_CreateIndirect, "Text", ID_TEXT_31, 255, 30, 50, 20, 0, 0x64, 0 },
  { TEXT_CreateIndirect, "Text", ID_TEXT_32, 255, 110, 50, 20, 0, 0x64, 0 },

  { TEXT_CreateIndirect, "Text", ID_TEXT_40, 335, 10, 50, 20, 0, 0x64, 0 },
  { TEXT_CreateIndirect, "Text", ID_TEXT_41, 335, 30, 50, 20, 0, 0x64, 0 },
  { TEXT_CreateIndirect, "Text", ID_TEXT_42, 335, 110, 50, 20, 0, 0x64, 0 }
};

/*********************************************************************
*
*       Static code
*
**********************************************************************
*/

/*********************************************************************
*
*       _cbDialog
*/
static void _cbDialog(WM_MESSAGE * pMsg) {
  WM_HWIN                    hItem;
  int                        i;
  U32                        v;
  char                      tempMinMax[16];

  switch (pMsg->MsgId) {
  case WM_INIT_DIALOG:

    for (i = 0; i < 5; i++) {
      hItem = WM_GetDialogItem(pMsg->hWin, ID_TEXT_00 + i * 3);
      TEXT_SetTextAlign(hItem, GUI_TA_HCENTER | GUI_TA_VCENTER);
      TEXT_SetTextColor(hItem, COLOR_YELLOW);
      TEXT_SetFont(hItem, &GUI_Font_16_AA4);
      TEXT_SetText(hItem, "---");

      hItem = WM_GetDialogItem(pMsg->hWin, ID_TEXT_01 + i * 3);
      TEXT_SetTextAlign(hItem, GUI_TA_HCENTER | GUI_TA_VCENTER);
      TEXT_SetTextColor(hItem, COLOR_LIGHT);
      TEXT_SetFont(hItem, &GUI_Font_16_AA4);
      TEXT_SetText(hItem, "-- | --");

      hItem = WM_GetDialogItem(pMsg->hWin, ID_TEXT_02 + i * 3);
      TEXT_SetTextAlign(hItem, GUI_TA_HCENTER | GUI_TA_VCENTER);
      TEXT_SetTextColor(hItem, COLOR_BLUE);
      TEXT_SetFont(hItem, &GUI_Font_16_AA4);
      TEXT_SetText(hItem, "--%");
    }
    break;
  case WM_PAINT:
    GUI_SetBkColor(COLOR_BK);
    GUI_Clear();

    for(i = 0; i < 5; i++) {
      v = GetWeatherIconId(MAIN_aWeatherDay[i].acWeatherIcon);
      GUI_DrawBitmap(_apWeatherIcon[v], 80 * i + 15, 55);
    }
    break;
  case MESSAGE_UPDATE_WEATHER_FORECAST:
    for(i = 0; i < 5; i++) {
      hItem = WM_GetDialogItem(pMsg->hWin, ID_TEXT_00 + i * 3);
      TEXT_SetText(hItem, MAIN_aWeatherDay[i].acWeekday);
      hItem = WM_GetDialogItem(pMsg->hWin, ID_TEXT_01 + i * 3);
      
      strcpy(tempMinMax, MAIN_aWeatherDay[i].acTempMax);
      strcat(tempMinMax, " | ");
      strcat(tempMinMax, MAIN_aWeatherDay[i].acTempMin);
      TEXT_SetText(hItem, tempMinMax);

      hItem = WM_GetDialogItem(pMsg->hWin, ID_TEXT_02 + i * 3);
      TEXT_SetText(hItem, MAIN_aWeatherDay[i].acHumidity);
    }

    break;
  default:
    WM_DefaultProc(pMsg);
    break;
  }
}

/*********************************************************************
*
*       Public code
*
**********************************************************************
*/

/*********************************************************************
*
*       GUI_UpdateWeatherForecast()
*
* Function description
*   Updates the GUI to the correct weather
*/
void GUI_UpdateWeatherForecast(void) {
  WM_MESSAGE Message;

  Message.MsgId   =  MESSAGE_UPDATE_WEATHER_FORECAST;
  Message.hWin    = _hWin;
  WM_SendMessage(_hWin, &Message);

  WM_InvalidateWindow(_hWin);
}

/*********************************************************************
*
*       CreateWindow3
*/
WM_HWIN CreateWindow3(void) {
  _hWin = GUI_CreateDialogBox(_aDialogCreate, GUI_COUNTOF(_aDialogCreate), _cbDialog, WM_HBKWIN, 0, 0);
  return _hWin;
}

/*************************** End of file ****************************/
